import java.lang.reflect.*;

public class CS590_Exam_Q4
{
   public static void main(String[] args)
   {
      Object obj = callMathMethod("max", "int", "-1", "int", "-5");
      System.out.println( obj );

      obj = callMathMethod("nextAfter", "double", "1", "double", "2");
      System.out.println( obj );

      obj = callMathMethod("nextAfter", "float", "1", "double", "2");
      System.out.println( obj );
   }

   public static Object callMathMethod( String methodName,
                                        String param1Type,
                                        String param1Arg,
                                        String param2Type,
                                        String param2Arg )
   {
      Object result = null;
      Class<?> c = Math.class;
      try
      {
         // Write Java reflection code that invokes the method, from
         // the Math class, named methodName with two parameters of
         // types param1Type and param2Type. You need to do the following
         // steps. Each step should be done using Java's Reflection API.
         // 1.) Get the appropriate Method object.
         // 2.) Get a Constructor object for param1Type and instantiate
         //     an object using param1Arg as the constructor argument.
         //     (If param1Type is a primitive, you need to "promote" it
         //     to its wrapper class to get a constructor.)
         // 3.) Get a Constructor object for param2Type and instantiate
         //     an object using param2Arg as the constructor argument.
         // 4.) Invoke the method with the two argument objects.
         // (You can do these steps in just 10 lines of code.
         //  You may find the two helper functions below useful.)
      }
      catch (NoSuchMethodException e)     {e.printStackTrace();}
      catch (IllegalAccessException e)    {e.printStackTrace();}
      catch (IllegalArgumentException e)  {e.printStackTrace();}
      catch (InstantiationException e)    {e.printStackTrace();}
      catch (InvocationTargetException e) {e.printStackTrace();}

      return result;
   }


   public static Class<?> myGetClass(String typeString)
   {
      Class<?> cl = null;
      if (typeString.equals("byte"))
         cl = byte.class;
      else if (typeString.equals("short"))
         cl = short.class;
      else if (typeString.equals("char"))
         cl = char.class;
      else if (typeString.equals("int"))
         cl = int.class;
      else if (typeString.equals("long"))
         cl = long.class;
      else if (typeString.equals("float"))
         cl = float.class;
      else if (typeString.equals("double"))
         cl = double.class;
      else if (typeString.equals("boolean"))
         cl = boolean.class;
      else  // type is not the name of a primitive type
         try
         {
            cl = Class.forName(typeString);
         }
         catch (ClassNotFoundException e){e.printStackTrace();}
      return cl;
   }


   public static Class<?> primitive2Wrapper(Class<?> cl)
   {  // If cl is not a primitive type, all these cases will fall
      // through to the bottom and cl will be returned unchanged.
      if (cl == byte.class)
         cl = Byte.class;
      else if (cl == short.class)
         cl = Short.class;
      else if (cl == char.class)
         cl = Character.class;
      else if (cl == int.class)
         cl = Integer.class;
      else if (cl == long.class)
         cl = Long.class;
      else if (cl == float.class)
         cl = Float.class;
      else if (cl == double.class)
         cl = Double.class;
      else if (cl == boolean.class)
         cl = Boolean.class;
      return cl;
   }
}